//
// ecOperator.h
//
// $Id: ecOperator.h,v 1.3 2000/07/25 03:24:35 mcoletti Exp $
//

#ifndef EC_OPERATOR_H
#define EC_OPERATOR_H


//! Defines common interface for all operators that work on a population.
template<class Population>
class
ecSingleOperator
{
   public:

      virtual ~ecSingleOperator() {}
   
      //!
      virtual void init( Population & first ) = 0;

      //!
      virtual void cleanup( Population & first ) = 0;

}; // ecSingleOperator




//! Defines common interface for all operators that work on a two populations.
template<class Population>
class
ecDoubleOperator : public ecSingleOperator<Population>
{
   public:

      virtual ~ecDoubleOperator() {}
   
      //!
      virtual void init( Population & first, Population & second ) = 0;

      //!
      virtual void cleanup( Population & first, Population & second ) = 0;

}; // ecDoubleOperator


#endif
