//
// ecRandom.h
//


#ifndef EC_RANDOM_H
#define EC_RANDOM_H

// XXX should consider putting these in a namespace?

//! Initialize the random seed 
void init_rand( int seed );


//! returns an integer in [0..size-1]
int irand( int size );


//!  returns [0..1.0]
float frand( );


/**!    returns a uniform double precision floating point 
               random number in the range 0 <= frand <= 1
*/
double drand( void );


/**! 
   returns a normally distributed random number with zero
   mean and a variance of 1.0 using frand as the underlying
   uniform generator.

   SOURCE OF THE CODE :  Numerical Recipes in C  (page 217).
*/
double gauss();


//!   log2( float ):   returns the base 2 log of a float
float log2( float );

#endif
